/*****************************************************************************
 * Copyright (c) 2019, Nsing Technologies Pte. Ltd.
 *
 * All rights reserved.
 * ****************************************************************************
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the disclaimer below.
 *
 * Nsing' name may not be used to endorse or promote products derived from
 * this software without specific prior written permission.
 *
 * DISCLAIMER: THIS SOFTWARE IS PROVIDED BY Nsing "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * DISCLAIMED. IN NO EVENT SHALL Nsing BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ****************************************************************************/

/**
 * @file rtc_hal.h
 * @author Nsing
 * @version v1.0.1
 * @copyright Copyright (c) 2019, Nsingechnologies Pte. Ltd. All rights reserved.
 */

#ifndef __RTC_HAL_H__
#define __RTC_HAL_H__

#ifdef __cplusplus
extern "C" {
#endif
    
#include "main.h"

#define RTC_CLK_SRC_LSI             (RCC_RTCCLK_SRC_LSI)
#define RTC_CLK_SRC_LSE             (RCC_RTCCLK_SRC_LSE|RCC_LSE_ENABLE)
#define RTC_CLK_SRC_LSE_BYPASS      (RCC_RTCCLK_SRC_LSE|RCC_LSE_BYPASS)
#define RTC_CLK_SRC_HSE_DIV128      (RCC_RTCCLK_SRC_HSE_DIV128)


typedef struct _SYSTEM_TIME_T
{
    RTC_DateType    Date;
    RTC_TimeType    Time;
} SYSTEM_TIME_T;

void rtc_time_get(SYSTEM_TIME_T* system_date);
void rtc_time_set(SYSTEM_TIME_T* DateTime, uint32_t format);
void RTC_CLKSourceConfig(uint32_t ClkSrc);

#ifdef __cplusplus
}
#endif

#endif //__RTC_HAL_H__

